/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.engine.error;

import java.awt.Component;
import java.awt.Font;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Calendar;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.SwingConstants;

/**
 *
 * @author gacek
 */
public class ErrorDisplayPanel extends javax.swing.JPanel
{

    /**
     * Creates new form DisplayPanel
     */
    public ErrorDisplayPanel()
    {
        initComponents();
        timeLabel.setText(getTime());
    }

    public JTabbedPane getTabs()
    {
        return tabs;
    }

    public void addActionListener(ActionListener al)
    {
        ignoreButton.addActionListener(al);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new JPanel();
        smileLabel = new JLabel();
        jLabel1 = new JLabel();
        tabs = new JTabbedPane();
        printButton = new JButton();
        timeLabel = new JLabel();
        ignoreButton = new JButton();

        smileLabel.setHorizontalAlignment(SwingConstants.CENTER);
        smileLabel.setText(":-)");

        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(Alignment.LEADING)
                        .addComponent(smileLabel, GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE)
                );
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(Alignment.LEADING)
                        .addComponent(smileLabel, GroupLayout.DEFAULT_SIZE, 195, Short.MAX_VALUE)
                );

        jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setText("EXCEPTION");

        printButton.setFont(new Font("Dialog", 0, 10)); // NOI18N
        printButton.setText("print stack");
        printButton.setMargin(new Insets(2, 0, 2, 0));
        printButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                printButtonActionPerformed(evt);
            }
        });

        timeLabel.setFont(new Font("Dialog", 0, 10)); // NOI18N
        timeLabel.setText(".");

        ignoreButton.setText("Ignore");
        ignoreButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                ignoreButtonActionPerformed(evt);
            }
        });

        GroupLayout layout = new GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(Alignment.TRAILING, layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(Alignment.TRAILING)
                                        .addComponent(tabs, Alignment.LEADING)
                                        .addComponent(jLabel1, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addGroup(layout.createSequentialGroup()
                                                .addComponent(printButton)
                                                .addPreferredGap(ComponentPlacement.RELATED)
                                                .addComponent(timeLabel, GroupLayout.PREFERRED_SIZE, 186, GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addComponent(ignoreButton, GroupLayout.PREFERRED_SIZE, 108, GroupLayout.PREFERRED_SIZE)))
                                .addContainerGap())
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel1)
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addComponent(tabs, GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                                .addGap(6, 6, 6)
                                .addGroup(layout.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(ignoreButton)
                                        .addComponent(timeLabel, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE)
                                        .addComponent(printButton, GroupLayout.PREFERRED_SIZE, 25, GroupLayout.PREFERRED_SIZE))
                                .addContainerGap())
                );
    }// </editor-fold>//GEN-END:initComponents

    private void printButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_printButtonActionPerformed
        int compNr = tabs.getComponentCount();
        Component comp;
        for (int i = 0; i < compNr; i++) {
            comp = tabs.getComponentAt(i);
            if (comp instanceof VNErrorPanel) {
                ((VNErrorPanel) comp).getException().printStackTrace();
            }
            if (comp instanceof ErrorPanel) {
                ((ErrorPanel) comp).getException().printStackTrace();
            }
        }
    }//GEN-LAST:event_printButtonActionPerformed

    private void ignoreButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_ignoreButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ignoreButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JButton ignoreButton;
    private JLabel jLabel1;
    private JPanel jPanel1;
    private JButton printButton;
    private JLabel smileLabel;
    private JTabbedPane tabs;
    private JLabel timeLabel;

    // End of variables declaration//GEN-END:variables
    private static String getTime()
    {
        String ret = "";
        Calendar cal = Calendar.getInstance();

        ret += cal.get(Calendar.YEAR) + "-";
        ret += (cal.get(Calendar.MONTH) + 1) + "-";
        ret += cal.get(Calendar.DAY_OF_MONTH) + " ";
        ret += cal.get(Calendar.HOUR_OF_DAY) + ":";
        ret += cal.get(Calendar.MINUTE) + "::";
        ret += cal.get(Calendar.SECOND) + ".";
        int ms = cal.get(Calendar.MILLISECOND);
        if (ms < 100)
            ret += "0";
        if (ms < 10)
            ret += "0";
        ret += ms;

        return ret;
    }

}
